"""
        COPYRIGHT (c) 2019-2023 by Featuremine Corporation.
        
        This Source Code Form is subject to the terms of the Mozilla Public
        License, v. 2.0. If a copy of the MPL was not distributed with this
        file, You can obtain one at https://mozilla.org/MPL/2.0/.
"""

from typing import Tuple, List

class sys:
    def __init__(self) -> None: ...
    def get_paths(self) -> List[str]: ...
    def set_paths(self, paths: List[str]) -> None: ...
    def get_module(self, name: str) -> int: ...
    def get_component_type(self, module: int, name: str) -> int: ...
    def get_module_filepath(self, module: int) -> str: ...
    def get_component_type_spec(self, component_type: int) -> List[Tuple[str, str, bool]]: ...

class reactor:
    def __init__(self) -> None: ...
    def run(self, live: bool, checksignals: bool) -> None: ...
    def run_once(self, now: int) -> bool: ...
    def stop(self) -> None: ...
    def sched(self) -> int: ...

class component:
    def __init__(self, reactor: reactor, component_type: int, inputs: list, config: dict) -> None: ...
    def out_idx(self, name: str) -> int: ...
    def out_sz(self) -> int: ...
